/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2008 Bull S.A.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */
package org.ow2.jonas.lib.management.extensions.base;

import javax.management.MalformedObjectNameException;
import javax.management.ObjectName;

import org.ow2.jonas.lib.management.tools.ManagementRepr;
import org.ow2.jonas.lib.management.tools.WhereAreYou;


/**
 * Base class for a JOnAS server management.
 * This class is extended by classes specialized for specific management aspects.
 * @author Adriana.Danes@bull.net
 * @author Oualaa Hani
 */
public class BaseManagement {
    /**
     * Current server name.
     */
    private String serverName = null;
    /**
     * Current domain name.
     */
    private String domainName = null;

    /**
     * Base constructor.
     */
    public BaseManagement() {
        serverName = WhereAreYou.getServerName();
        domainName = WhereAreYou.getDomainName();
    }

    /**
     * @return The current server name.
     */
    public String getServerName() {
        return serverName;
    }

    /**
     * @return The current domain name.
     */
    public String getDomainName() {
        return domainName;
    }

    /**
     * @param p_ObjectName Instance of ObjectName to access to MBean
     * @param ps_AttrName Attribute name of MBean
     * @return The value of attribute
     */
    protected String getStringAttribute(final ObjectName p_ObjectName, final String ps_AttrName) {
        String pServer = getServerName();
        String s = (String) ManagementRepr.getAttribute(p_ObjectName, ps_AttrName, pServer);
        return s;
    }

    /**
     * @param p_ObjectName Instance of ObjectName to access to MBean
     * @param ps_AttrName Attribute name of MBean
     * @return The value of attribute
     */
    protected int getIntegerAttribute(final ObjectName p_ObjectName, final String ps_AttrName) {
        String pServer = getServerName();
        Integer o = (Integer) ManagementRepr.getAttribute(p_ObjectName, ps_AttrName, pServer);
        return o.intValue();
    }

    /**
     * Return the value of a key property of a String ObjectName
     * @param p_ObjectName OBJECT_NAME
     * @return key value
     */
    protected String getKeyValue(final String p_ObjectName, final String ps_keyName) {
        ObjectName on = null;
        try {
            on = ObjectName.getInstance(p_ObjectName);
        } catch (MalformedObjectNameException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            return null;
        } catch (NullPointerException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            return null;
        }
        return on.getKeyProperty(ps_keyName);
    }

    /**
     * Return the values of a key property of String ObjectNames
     * @param p_ObjectName OBJECT_NAME
     * @param ps_keyName key name
     * @return array of key values
     */
    protected String[] getKeyValues(final String[] p_ObjectNames, final String ps_keyName) {
        ObjectName on = null;
        String[] keyValues = new String[p_ObjectNames.length];
        for (int i = 0; i < p_ObjectNames.length; i++) {
            String s_on = p_ObjectNames[i];
            try {
                on = ObjectName.getInstance(s_on);
            } catch (MalformedObjectNameException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
                keyValues[i] = null;
            } catch (NullPointerException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
                keyValues[i] = null;
            }
            keyValues[i] = on.getKeyProperty(ps_keyName);
        }
        return keyValues;
    }
}
